package de.jatitv.commandguiv2.Spigot.cmdManagement;

import de.jatitv.commandguiv2.Spigot.config.languages.SelectMessages;
import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Spigot.objects.guis.Gui;
import de.jatitv.commandguiv2.Spigot.config.config.SelectConfig;
import de.jatitv.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class Help {
    private static String prefix = Util.getPrefix();

    public static void sendHelp(CommandSender sender, String Prefix) {
        Gui gui = Main.guiHashMap.get(SelectConfig.getDefaultGUI());

        T2Csend.sender(sender, Prefix + " §8----- §4Command§9GUI §chelp §8-----");
        cgui(sender, gui);
        open(sender);
        help(sender);
        gUIItemHelp(sender);
        info(sender);
        give(sender);
        createDefaultGUI(sender);
        reload(sender);
        T2Csend.sender(sender, Prefix + " §8-------------------------");
    }


    private static void cgui(CommandSender sender, Gui gui) {
        if (!sender.hasPermission("commandgui.command")) return;

        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpCgui.replace("[gui]", T2Creplace.replace(prefix, gui.guiName)));
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpCgui.replace("[gui]", T2Creplace.replace(prefix, gui.guiName)));
    }

    private static void open(CommandSender sender) {
        if (!sender.hasPermission("commandgui.command")) return;

        for (String alias : Main.allAliases) {
            if (Main.guiHashMap.get(alias).guiEnable || sender.hasPermission("commandgui.bypass")) {
                if (sender instanceof Player) {
                    T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpOpen.replace("[gui]", alias).replace("[guiname]", T2Creplace.replace(prefix, Main.guiHashMap.get(alias).guiName)));
                } else
                    T2Csend.sender(sender, prefix + " " + SelectMessages.HelpOpen.replace("[gui]", alias).replace("[guiname]", T2Creplace.replace(prefix, Main.guiHashMap.get(alias).guiName)));
            }
        }
    }

    private static void help(CommandSender sender) {
        if (!sender.hasPermission("commandgui.command")) return;

        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpHelp);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpHelp);
    }

    private static void info(CommandSender sender) {
        if (!sender.hasPermission("commandgui.command.info")) return;

        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpInfo);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpInfo);
    }

    private static void give(CommandSender sender) {
        if (!sender.hasPermission("commandgui.admin")) return;
        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpGive);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpGive);
    }

    private static void createDefaultGUI(CommandSender sender) {
        if (!sender.hasPermission("commandgui.admin")) return;
        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpCreateDefaultGUI.replace("[directory]", Main.getPath() + "\\GUIs\\default.yml"));
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpCreateDefaultGUI.replace("[directory]", Main.getPath() + "\\GUIs\\default.yml"));
    }

    private static void reload(CommandSender sender) {
        if (!sender.hasPermission("commandgui.admin")) return;
        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerHelpReload);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.HelpReload);
    }


    public static void gUIItemHelp(CommandSender sender) {
        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerGUIItemHelp_on);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.GUIItemHelp_on);

        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerGUIItemHelp_off);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.GUIItemHelp_off);

        if (sender instanceof Player) {
            T2Csend.player((Player) sender, prefix + " " + SelectMessages.PlayerGUIItemHelp_Slot);
        } else T2Csend.sender(sender, prefix + " " + SelectMessages.GUIItemHelp_Slot);
    }

    public static void sendGUIItemHelp(CommandSender sender) {
        if (sender.hasPermission("commandgui.useitem.toggle")) {
            T2Csend.sender(sender, prefix + " §8------ §4Command§9GUI§2Item §chelp §8------");
            gUIItemHelp(sender);
            T2Csend.sender(sender, prefix + " §8------------------------------");
        }
    }
}
