package de.jatitv.commandguiv2.Spigot.objects.functions;

import de.jatitv.commandguiv2.Spigot.enums.EcoEnum;
import de.jatitv.commandguiv2.Spigot.enums.FunctionItemEnum;
import de.jatitv.commandguiv2.Spigot.enums.FunctionVoteEnum;

import java.util.List;

public class Function {

    public String key;
    public Boolean empty;
    public Integer itemAmount;
    public Boolean playerHead_Enable;
    public Boolean base64_Enable;
    public String base64Value;
    public Boolean playerWhoHasOpenedTheGUI;
    public String playerName;
    public String item;
    public String name;
    public List<String> lore;
    public Boolean noPermMessageEnable;
    public String customNoPermMessage;
    public Boolean noPermLoreEnable;
    public List<String> noPermLore;
    public Boolean customSound_Enable;
    public Boolean customSound_NoSound;
    public String customSound_Sound;
    public Boolean cost_Enable;
    public EcoEnum ecoModule;
    public String ecoItem;
    public Integer votePoints;
    public Double price;
    public Boolean command_Enable;
    public Boolean command_BungeeCommand;
    public Boolean commandAsConsole;
    public Boolean serverChange;
    public String serverChangeServer;
    public List<String> command;
    public Boolean openGUI_Enable;
    public String openGUI;
    public Boolean togglePermission;
    public String togglePermissionPerm;
    public Boolean toggleUseItem;
    public Boolean message_Enable;
    public List<String> message;
    public Boolean setConfigEnable;
    public String configFilePath;
    public String configOptionPath;
    public String configOptionPremat;

    public String configStringValueLeft;
    public Boolean configBooleanValueLeft;
    public Integer configIntegerValueLeft;
    public Double configDoubleValueLeft;
    public List<String> configListValueLeft;

    public String configStringValueRight;
    public Boolean configBooleanValueRight;
    public Integer configIntegerValueRight;
    public Double configDoubleValueRight;
    public List<String> configListValueRight;


    public Boolean pluginReloadEnable;
    public String pluginReloadCommand;
    public Boolean functionVotePoints;
    public FunctionVoteEnum functionVotePointsMode;
    public Integer functionVotePointsAmount;
    public Boolean functionItem;
    public FunctionItemEnum functionItemMode;
    public String functionItemItem;

    public Function(String key,
                    Boolean empty,
                    Integer itemAmount,
                    Boolean playerHead_Enable,
                    Boolean base64Value_Enable,
                    String base64Value,
                    Boolean playerWhoHasOpenedTheGUI,
                    String playerName,
                    String item,
                    String name,
                    List<String> lore,
                    Boolean noPermMessageEnable,
                    String customNoPermMessage,
                    Boolean noPermLoreEnable,
                    List<String> noPermLore,
                    Boolean customSound_Enable,
                    Boolean customSound_NoSound,
                    String customSound_Sound,
                    Boolean cost_Enable,
                    EcoEnum ecoModule,
                    String ecoItem,
                    Integer votePoints,
                    Double price,
                    Boolean command_Enable,
                    Boolean command_BungeeCommand,
                    Boolean commandAsConsole,
                    List<String> command,
                    Boolean serverChange,
                    String serverChangeServer,
                    Boolean openGUI_Enable,
                    String openGUI,
                    Boolean togglePermission,
                    String togglePermissionPerm,
                    Boolean toggleUseItem,
                    Boolean message_Enable,
                    List<String> message,
                    Boolean setConfigEnable,
                    String configFilePath,
                    String configOptionPath,
                    String configOptionPremat,

                    String configStringValueLeft,
                    Boolean configBooleanValueLeft,
                    Integer configIntegerValueLeft,
                    Double configDoubleValueLeft,
                    List<String> configListValueLeft,

                    String configStringValueRight,
                    Boolean configBooleanValueRight,
                    Integer configIntegerValueRight,
                    Double configDoubleValueRight,
                    List<String> configListValueRight,

                    Boolean pluginReloadEnable,
                    String pluginReloadCommand,
                    Boolean functionVotePoints,
                    FunctionVoteEnum functionVotePointsMode,
                    Integer functionVotePointsAmount,
                    Boolean functionItem,
                    FunctionItemEnum functionItemMode,
                    String functionItemItem) {
        this.key = key;
        this.empty = empty;
        this.itemAmount = itemAmount;
        this.playerHead_Enable = playerHead_Enable;
        this.base64_Enable = base64Value_Enable;
        this.base64Value = base64Value;
        this.playerWhoHasOpenedTheGUI = playerWhoHasOpenedTheGUI;
        this.playerName = playerName;
        this.item = item;
        this.name = name;
        this.lore = lore;
        this.noPermMessageEnable = noPermMessageEnable;
        this.customNoPermMessage = customNoPermMessage;
        this.noPermLoreEnable = noPermLoreEnable;
        this.noPermLore = noPermLore;
        this.customSound_Enable = customSound_Enable;
        this.customSound_NoSound = customSound_NoSound;
        this.customSound_Sound = customSound_Sound;
        this.cost_Enable = cost_Enable;
        this.ecoModule = ecoModule;
        this.ecoItem = ecoItem;
        this.votePoints = votePoints;
        this.price = price;
        this.command_Enable = command_Enable;
        this.command_BungeeCommand = command_BungeeCommand;
        this.commandAsConsole = commandAsConsole;
        this.command = command;
        this.serverChange = serverChange;
        this.serverChangeServer = serverChangeServer;
        this.openGUI_Enable = openGUI_Enable;
        this.openGUI = openGUI;
        this.togglePermission = togglePermission;
        this.togglePermissionPerm = togglePermissionPerm;
        this.toggleUseItem = toggleUseItem;
        this.message_Enable = message_Enable;
        this.message = message;
        this.setConfigEnable = setConfigEnable;
        this.configFilePath = configFilePath;
        this.configOptionPath = configOptionPath;
        this.configOptionPremat = configOptionPremat;
        //   this.ConfigChatInput = ConfigChatInput;

        this.configStringValueLeft = configStringValueLeft;
        this.configBooleanValueLeft = configBooleanValueLeft;
        this.configIntegerValueLeft = configIntegerValueLeft;
        this.configDoubleValueLeft = configDoubleValueLeft;
        this.configListValueLeft = configListValueLeft;

        this.configStringValueRight = configStringValueRight;
        this.configBooleanValueRight = configBooleanValueRight;
        this.configIntegerValueRight = configIntegerValueRight;
        this.configDoubleValueRight = configDoubleValueRight;
        this.configListValueRight = configListValueRight;


        this.pluginReloadEnable = pluginReloadEnable;
        this.pluginReloadCommand = pluginReloadCommand;

        this.functionVotePoints = functionVotePoints;
        this.functionVotePointsMode = functionVotePointsMode;
        this.functionVotePointsAmount = functionVotePointsAmount;
        this.functionItem = functionItem;
        this.functionItemMode = functionItemMode;
        this.functionItemItem = functionItemItem;


    }
}
